# Supported languages, frameworks, and feature availability overview

Get an overview of supported languages and package managers across Snyk environments, including feature availability for open source and licensing (Snyk Open Source) and code analysis (Snyk Code).

## Open source and licensing (Snyk Open Source)

The following table lists the programming languages, fully supported package managers, and features for Snyk Open Source.

<table data-full-width="false"><thead><tr><th width="247">Language and package manager</th><th width="146" align="center">Git integration (SCM)</th><th width="106" align="center">Snyk CLI, plugins (IDE), CI/CD</th><th>Features</th><th>Package manager version</th></tr></thead><tbody><tr><td><p><a href=".net/"><strong>.NET</strong></a></p><ul><li><strong>NuGet</strong></li><li><strong>Paket</strong></li></ul></td><td align="center">NuGet</td><td align="center"><strong>✔︎</strong></td><td><ul><li>Fix PRs (NuGet)</li><li>License scanning</li><li>Reports</li></ul></td><td>Not applicable</td></tr><tr><td><a href="c-c++.md"><strong>C/C++</strong></a></td><td align="center"><span data-gb-custom-inline data-tag="emoji" data-code="2796">➖</span></td><td align="center"><strong>✔︎</strong></td><td><ul><li>License scanning</li></ul><ul><li>Reports</li></ul></td><td>Not applicable</td></tr><tr><td><p><a href="../../scan-application-code/snyk-open-source/snyk-open-source-supported-languages-and-package-managers/snyk-for-elixir.md"><strong>Elixir</strong></a></p><ul><li><strong>Hex</strong></li></ul></td><td align="center"><span data-gb-custom-inline data-tag="emoji" data-code="2796">➖</span></td><td align="center"><strong>✔︎</strong></td><td><ul><li>License scanning</li></ul><ul><li>Reports</li></ul></td><td>Not applicable</td></tr><tr><td><p><a href="../../scan-application-code/snyk-open-source/snyk-open-source-supported-languages-and-package-managers/snyk-for-go.md"><strong>Go</strong></a></p><ul><li><strong>Go Modules</strong></li><li><strong>dep</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>License scanning</li></ul><ul><li>Reports</li></ul></td><td>Not applicable</td></tr><tr><td><p><a href="java-and-kotlin.md"><strong>Java and Kotlin</strong></a></p><ul><li><strong>Maven</strong></li><li><strong>Gradle</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Fix PRs (Maven)</li></ul><ul><li>License scanning</li></ul><ul><li>Reports</li></ul></td><td><p></p><p>Maven</p><ul><li><code>3.*</code> For details, see the <a href="https://github.com/snyk/snyk-mvn-plugin#support">Snyk Maven plugin readme</a>.</li></ul><p>Gradle</p><ul><li><code>4.*</code>, <code>5.*</code>, <code>6.*</code>, <code>7.*</code> For more information, see the <a href="https://github.com/snyk/snyk-gradle-plugin#support">Snyk Gradle plugin readme</a>.</li></ul></td></tr><tr><td><p><a href="javascript.md"><strong>JavaScript</strong></a></p><ul><li><strong>npm</strong></li><li><strong>Yarn</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Fix PRs</li></ul><ul><li>License scanning</li></ul><ul><li>Reports</li></ul></td><td><p></p><p>npm</p><ul><li><code>Lockfile 1, Lockfile 2, Lockfile 3, 7.*</code> For details, see the <a href="javascript.md#npm">Snyk Javascript </a>page.</li></ul><p>Yarn</p><ul><li><code>Yarn 1, Yarn 2, Yarn 3</code>. For more information, see the <a href="javascript.md#yarn">Snyk Javascript </a>page.</li></ul></td></tr><tr><td><p><a href="../../scan-application-code/supported-languages-and-frameworks/broken-reference/"><strong>PHP</strong></a></p><ul><li><strong>Composer</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>License scanning</li></ul><ul><li>Reports</li></ul></td><td>Not applicable</td></tr><tr><td><p><a href="python.md"><strong>Python</strong></a></p><ul><li><strong>Pip</strong></li><li><strong>Poetry</strong></li><li><strong>pipenv</strong></li><li><strong>setup.py</strong></li></ul></td><td align="center">Pip and Poetry</td><td align="center"><strong>✔︎</strong></td><td><ul><li>Fix PRs (Pip)</li></ul><ul><li>License scanning</li></ul><ul><li>Reports</li></ul></td><td>Suitable with <code>Python 2 -> 2.7.16</code>, and <code>Python  3 -> 3.7.4</code>.</td></tr><tr><td><p><a href="broken-reference"><strong>Ruby</strong></a></p><ul><li><strong>Bundler</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Fix PRs</li></ul><ul><li>License scanning</li></ul><ul><li>Reports</li></ul></td><td>All Gemfile and Gemfile.lock compatible with the <a href="ruby.md#supported-ruby-versions">Snyk supported Ruby versions</a>. </td></tr><tr><td><p><a href="broken-reference"><strong>Scala</strong></a></p><ul><li><strong>sbt</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>License scanning</li></ul><ul><li>Reports</li></ul></td><td>Not applicable</td></tr><tr><td><p><a href="swift-and-objective-c.md"><strong>Swift and Objective-C</strong></a></p><ul><li><strong>CocoaPods</strong></li><li><strong>Swift Package Manager</strong></li></ul></td><td align="center">CocoaPods</td><td align="center"><strong>✔︎</strong></td><td><ul><li>License scanning (CocoaPods)</li></ul><ul><li>Reports</li></ul></td><td><p></p><p>CocoaPods</p><ul><li>Swift Package Manager</li></ul><ul><li><code>Swift v3.0</code> or higher.</li></ul></td></tr></tbody></table>

## Code analysis (Snyk Code)

The following table lists the programming languages and fully supported frameworks and features for Snyk Code.

<table data-full-width="false"><thead><tr><th width="232">Language and framework</th><th width="131" align="center">Git integration (SCM)</th><th width="207" align="center">Snyk CLI, plugins (IDE), CI/CD</th><th>Features</th></tr></thead><tbody><tr><td><strong>Apex</strong></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Reports</li><li>Custom rules</li></ul></td></tr><tr><td><p><strong>C#</strong></p><ul><li><strong>.NET</strong></li><li><strong>ASP.NET</strong></li><li><strong>.NET Core</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Reports</li></ul><ul><li>Custom rules</li></ul></td></tr><tr><td><p><a href="c-c++.md"><strong>C/C++</strong></a> <strong>(beta)</strong></p><ul><li><strong>C++ Standard Library</strong></li><li><strong>POSIX</strong></li><li><strong>Win32</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td>Reports</td></tr><tr><td><strong>Go</strong></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Reports</li></ul><ul><li>Custom rules</li></ul></td></tr><tr><td><p><a href="java-and-kotlin.md"><strong>Java</strong></a></p><ul><li><strong>Apache Camel</strong></li><li><strong>Apache Struts</strong></li><li><strong>Spring MVC</strong></li><li><strong>Spring JDBC</strong></li><li><strong>Jakarta XML Services</strong></li><li><strong>Dropwizard</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Reports</li></ul><ul><li>Custom rules</li></ul></td></tr><tr><td><p><a href="javascript.md"><strong>JavaScript</strong></a></p><ul><li><strong>React</strong></li><li><strong>Vue.js</strong></li><li><strong>Express</strong></li><li><strong>JQuery</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Reports</li></ul><ul><li>Custom rules</li></ul></td></tr><tr><td><a href="java-and-kotlin.md"><strong>Kotlin</strong></a> <strong>(beta)</strong></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td>Reports</td></tr><tr><td><p><strong>PHP</strong></p><ul><li><strong>Symfony</strong></li><li><strong>Laravel</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Reports</li></ul><ul><li>Custom rules</li></ul></td></tr><tr><td><p><a href="python.md"><strong>Python</strong></a></p><ul><li><strong>Django</strong></li><li><strong>Flask</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Reports</li></ul><ul><li>Custom rules</li></ul></td></tr><tr><td><p><a href="ruby.md"><strong>Ruby</strong></a></p><ul><li><strong>Ruby On Rails</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Reports</li></ul><ul><li>Custom rules</li></ul></td></tr><tr><td><p><a href="scala.md"><strong>Scala</strong></a> </p><ul><li><strong>Play</strong></li><li><strong>Akka</strong></li><li><strong>HTTP4S</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td>Reports</td></tr><tr><td><p><a href="swift-and-objective-c.md"><strong>Swift</strong></a> </p><ul><li><strong>AlamoFire</strong></li><li><strong>Pathos</strong></li><li><strong>SQLite</strong></li><li><strong>CryptoKit</strong></li></ul></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td>Reports</td></tr><tr><td><strong>TypeScript</strong></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td><ul><li>Reports</li></ul><ul><li>Custom rules</li></ul></td></tr><tr><td><strong>VB.NET (beta)</strong></td><td align="center"><strong>✔︎</strong></td><td align="center"><strong>✔︎</strong></td><td>Reports</td></tr></tbody></table>
